## ros-rolling-rmf-fleet-adapter 1.4.0

=== rmf_rxcpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(Threads REQUIRED)

add_library(rmf_rxcpp INTERFACE)

target_include_directories(rmf_rxcpp
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/RxCpp-4.1.0/Rx/v2/src
    ${rclcpp_INCLUDE_DIRS}
)
target_link_libraries(rmf_rxcpp
  INTERFACE
    Threads::Threads
    ${rclcpp_LIBRARIES}
)

if(BUILD_TESTING)
  find_package(ament_cmake_catch2 REQUIRED)
  find_package(rmf_utils REQUIRED)
  find_package(std_msgs REQUIRED)
  find_package(rmf_cmake_uncrustify REQUIRED)
  find_file(uncrustify_config_file NAMES 
    NAMES "rmf_code_style.cfg"
    PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")

  ament_add_catch2(
    test_rmf_rxcpp
      test/main.cpp
      test/test_RxJobs.cpp
      test/test_Transport.cpp
  )
  target_include_directories(test_rmf_rxcpp
    PRIVATE
      ${std_msgs_INCLUDE_DIRS}
  )
  target_link_libraries(test_rmf_rxcpp
    PRIVATE
      rmf_rxcpp
      rmf_utils::rmf_utils
      ${std_msgs_LIBRARIES}
  )

  find_package(rmf_traffic REQUIRED)

  add_executable(rmf_rxcpp_example_plan_path examples/PlanPath.cpp)

  target_link_libraries(rmf_rxcpp_example_plan_path
    PUBLIC
      rmf_traffic::rmf_traffic
      rmf_rxcpp
  )

endif()

=== rmf_rxcpp/RxCpp-4.1.0/Rx/v2/examples/awaitable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

get_filename_component(SAMPLE_PROJECT "${CMAKE_CURRENT_SOURCE_DIR}" NAME)

project(${SAMPLE_PROJECT} LANGUAGES C CXX)

# define some folders
get_filename_component(RXCPP_DIR "${CMAKE_CURRENT_SOURCE_DIR}" PATH)
get_filename_component(RXCPP_DIR "${RXCPP_DIR}" PATH)
get_filename_component(RXCPP_DIR "${RXCPP_DIR}" PATH)
get_filename_component(RXCPP_DIR "${RXCPP_DIR}" PATH)

MESSAGE( STATUS "RXCPP_DIR: " ${RXCPP_DIR} )

include(${RXCPP_DIR}/projects/CMake/shared.cmake)

# define the sources
set(SAMPLE_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)
add_executable(${SAMPLE_PROJECT} ${SAMPLE_SOURCES})
add_executable(rxcpp::examples::${SAMPLE_PROJECT} ALIAS ${SAMPLE_PROJECT})
target_compile_options(${SAMPLE_PROJECT} PUBLIC ${RX_COMPILE_OPTIONS} /await)
target_compile_features(${SAMPLE_PROJECT} PUBLIC ${RX_COMPILE_FEATURES})
target_include_directories(${SAMPLE_PROJECT} PUBLIC ${RX_SRC_DIR})
target_link_libraries(${SAMPLE_PROJECT} ${CMAKE_THREAD_LIBS_INIT})

# configure unit tests via CTest
enable_testing()
set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")

set_target_properties(${SAMPLE_PROJECT} PROPERTIES FOLDER "Examples")

add_test(NAME RunTests
     WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
     COMMAND ${SAMPLE_PROJECT} ${TEST_ARGS})

=== debian/changelog ===
ros-rolling-rmf-fleet-adapter (1.4.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Grey <grey@openrobotics.org>  Mon, 06 Sep 2021 05:05:08 -0000

=== debian/control ===
Source: ros-rolling-rmf-fleet-adapter
Section: misc
Priority: optional
Maintainer: Grey <grey@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libyaml-cpp-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-catch2, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rmf-battery, ros-rolling-rmf-cmake-uncrustify, ros-rolling-rmf-dispenser-msgs, ros-rolling-rmf-door-msgs, ros-rolling-rmf-fleet-msgs, ros-rolling-rmf-ingestor-msgs, ros-rolling-rmf-lift-msgs, ros-rolling-rmf-task, ros-rolling-rmf-task-msgs, ros-rolling-rmf-traffic, ros-rolling-rmf-traffic-ros2, ros-rolling-rmf-utils, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rmf-fleet-adapter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rmf-battery, ros-rolling-rmf-dispenser-msgs, ros-rolling-rmf-door-msgs, ros-rolling-rmf-fleet-msgs, ros-rolling-rmf-ingestor-msgs, ros-rolling-rmf-lift-msgs, ros-rolling-rmf-task, ros-rolling-rmf-task-msgs, ros-rolling-rmf-traffic, ros-rolling-rmf-traffic-ros2, ros-rolling-rmf-utils, ros-rolling-std-msgs, ros-rolling-ros-workspace
Description: Fleet Adapter package for RMF fleets.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rmf-fleet-adapter//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rmf-fleet-adapter 2.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

project(rmf_fleet_adapter)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(yaml-cpp REQUIRED)
find_package(Threads REQUIRED)
if(DEFINED ENV{RMF_ENABLE_FAILOVER})
  if($ENV{RMF_ENABLE_FAILOVER} EQUAL 1)
    find_package(stubborn_buddies REQUIRED)
    find_package(stubborn_buddies_msgs REQUIRED)
  endif()
endif()
include(GNUInstallDirs)

set(dep_pkgs
  rclcpp
  rclcpp_components
  rmf_utils
  rmf_dispenser_msgs
  rmf_ingestor_msgs
  rmf_door_msgs
  rmf_fleet_msgs
  rmf_lift_msgs
  rmf_task_msgs
  rmf_traffic_ros2
  rmf_task_ros2
  rmf_battery
  rmf_task
  rmf_task_sequence
  std_msgs
  rmf_api_msgs
  rmf_websocket
  rmf_building_map_msgs
  nlohmann_json
  nlohmann_json_schema_validator_vendor
)
foreach(pkg ${dep_pkgs})
  find_package(${pkg} REQUIRED)
endforeach()

if(BUILD_TESTING)
  find_package(ament_cmake_uncrustify REQUIRED)
  find_file(uncrustify_config_file
    NAMES "rmf_code_style.cfg"
    PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")

  ament_uncrustify(
    include src test rmf_rxcpp/include rmf_rxcpp/src rmf_rxcpp/test
    CONFIG_FILE ${uncrustify_config_file}
    LANGUAGE C++
    MAX_LINE_LENGTH 80
  )
endif()
# -----------------------------------------------------------------------------

add_subdirectory(rmf_rxcpp)

# -----------------------------------------------------------------------------

file(GLOB_RECURSE rmf_fleet_adapter_srcs "src/rmf_fleet_adapter/*.cpp")

add_library(rmf_fleet_adapter SHARED
  ${rmf_fleet_adapter_srcs}
)

ament_target_dependencies(rmf_fleet_adapter
  PUBLIC
    rmf_traffic_ros2
    rmf_task_ros2
    yaml-cpp
    rmf_fleet_msgs
    rmf_task_msgs
    rmf_door_msgs
    rmf_lift_msgs
    rmf_dispenser_msgs
    rmf_ingestor_msgs
    rmf_building_map_msgs
    rclcpp
)

target_link_libraries(rmf_fleet_adapter
  PUBLIC
    rmf_task::rmf_task
    rmf_task_sequence::rmf_task_sequence
    rmf_battery::rmf_battery
  PRIVATE
    rmf_rxcpp
    rmf_websocket::rmf_websocket
    nlohmann_json::nlohmann_json
    rmf_api_msgs::rmf_api_msgs
    nlohmann_json_schema_validator
)

target_include_directories(rmf_fleet_adapter
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/rmf_api_generate_schema_headers/include> # for auto-generated schema headers
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE
    ${rmf_door_msgs_INCLUDE_DIRS}
    ${rmf_lift_msgs_INCLUDE_DIRS}
    ${rmf_dispenser_msgs_INCLUDE_DIRS}
    ${rmf_ingestor_msgs_INCLUDE_DIRS}
    ${rmf_api_msgs_INCLUDE_DIRS}
    ${rmf_websocket_INCLUDE_DIR}
    ${rmf_traffic_ros2_INCLUDE_DIRS}
    ${rmf_building_map_msgs_INCLUDE_DIRS}
    ${nlohmann_json_schema_validator_INCLUDE_DIRS}
)

if (BUILD_TESTING)
  find_package(ament_cmake_catch2 REQUIRED)
  find_package(std_msgs REQUIRED)

  ament_add_catch2(
    test_rmf_fleet_adapter
      test/main.cpp
      test/phases/MockAdapterFixture.cpp
      test/phases/test_DoorOpen.cpp
      test/phases/test_DoorClose.cpp
      test/phases/test_RequestLift.cpp
      test/phases/test_DispenseItem.cpp
      test/phases/test_IngestItem.cpp
      test/services/test_FindEmergencyPullover.cpp
      test/services/test_FindPath.cpp
      test/services/test_Negotiate.cpp
      test/tasks/test_Delivery.cpp
      test/tasks/test_Loop.cpp
      test/test_Task.cpp
    TIMEOUT 300
  )
  ament_target_dependencies(test_rmf_fleet_adapter
    PUBLIC
      rmf_task_msgs
      rmf_door_msgs
      rmf_lift_msgs
      rmf_dispenser_msgs
      rmf_ingestor_msgs
      std_msgs
      rmf_building_map_msgs
      rmf_websocket
  )
  target_include_directories(test_rmf_fleet_adapter
    PRIVATE
      # private includes of rmf_fleet_adapter
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rmf_fleet_adapter>
      ${rmf_api_msgs_INCLUDE_DIRS}
      ${nlohmann_json_schema_validator_INCLUDE_DIRS}
  )
  target_link_libraries(test_rmf_fleet_adapter
    PRIVATE
      # private libraries of rmf_fleet_adapter
      rmf_rxcpp
      rmf_fleet_adapter
      rmf_utils::rmf_utils
      rmf_api_msgs::rmf_api_msgs
      nlohmann_json_schema_validator
  )

  target_compile_definitions(test_rmf_fleet_adapter
    PRIVATE
      "-DTEST_RESOURCES_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/test/resources/\"")

endif ()

# -----------------------------------------------------------------------------

add_executable(read_only
  src/read_only/main.cpp
  src/read_only/FleetAdapterNode.cpp
)

target_link_libraries(read_only
  PRIVATE
    rmf_fleet_adapter
)

# -----------------------------------------------------------------------------

add_executable(read_only_blockade
  src/read_only_blockade/main.cpp
  src/read_only_blockade/FleetAdapterNode.cpp
)

target_link_libraries(read_only_blockade
  PRIVATE
    rmf_fleet_adapter
)

# -----------------------------------------------------------------------------

add_executable(full_control src/full_control/main.cpp)

target_link_libraries(full_control
  PRIVATE
    rmf_fleet_adapter
    ${rmf_fleet_msgs_LIBRARIES}
    ${rmf_task_msgs_LIBRARIES}
)

target_include_directories(full_control
  PRIVATE
    ${rmf_fleet_msgs_INCLUDE_DIRS}
    ${rmf_task_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(mock_traffic_light src/mock_traffic_light/main.cpp)

target_link_libraries(mock_traffic_light
  PRIVATE
    rmf_fleet_adapter
    ${rmf_task_msgs_LIBRARIES}
    ${rmf_fleet_msgs_LIBRARIES}
)

target_include_directories(mock_traffic_light
  PRIVATE
    ${rmf_task_msgs_INCLUDE_DIRS}
    ${rmf_fleet_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(lift_supervisor
  src/lift_supervisor/main.cpp
  src/lift_supervisor/Node.cpp
)

target_link_libraries(lift_supervisor
  PRIVATE
    rmf_fleet_adapter
    ${rclcpp_LIBARRIES}
    ${rmf_lift_msgs_LIBRARIES}
    ${std_msgs_LIBRARIES}
)

target_include_directories(lift_supervisor
  PRIVATE
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_lift_msgs_INCLUDE_DIRS}
    ${std_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(experimental_lift_watchdog
  src/experimental_lift_watchdog/main.cpp
)

target_link_libraries(experimental_lift_watchdog
  PRIVATE
    ${rclcpp_LIBRARIES}
    ${rmf_fleet_msgs_LIBRARIES}
    ${std_msgs_LIBRARIES}
    Threads::Threads
)

target_include_directories(experimental_lift_watchdog
  PRIVATE
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_fleet_msgs_INCLUDE_DIRS}
    ${std_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(door_supervisor
  src/door_supervisor/main.cpp
  src/door_supervisor/Node.cpp
)

target_link_libraries(door_supervisor
  PRIVATE
    rmf_fleet_adapter
    ${rclcpp_LIBRARIES}
    ${rmf_door_msgs_LIBRARIES}
)

target_include_directories(door_supervisor
  PRIVATE
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_door_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_library(robot_state_aggregator_main SHARED
  src/robot_state_aggregator/RobotStateAggregator.cpp
)

target_include_directories(robot_state_aggregator_main
  PRIVATE
    include
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_fleet_msgs_INCLUDE_DIRS}
    ${stubborn_buddies_msgs_INCLUDE_DIRS})

target_compile_definitions(robot_state_aggregator_main
  PRIVATE "COMPOSITION_BUILDING_DLL"
)


if(DEFINED ENV{RMF_ENABLE_FAILOVER})
  if($ENV{RMF_ENABLE_FAILOVER} EQUAL 1)
    ament_target_dependencies(robot_state_aggregator_main
      "rclcpp"
      "rclcpp_components"
      "std_msgs"
      "stubborn_buddies_msgs"
      "rmf_fleet_msgs"
    )
  else()
    ament_target_dependencies(robot_state_aggregator_main
      "rclcpp"
      "rclcpp_components"
      "std_msgs"
      "rmf_fleet_msgs"
    )
  endif()
else()
  ament_target_dependencies(robot_state_aggregator_main
    "rclcpp"
    "rclcpp_components"
    "std_msgs"
    "rmf_fleet_msgs"
  )
endif()

rclcpp_components_register_nodes(robot_state_aggregator_main
  "RobotStateAggregator"
)

set(node_plugins "${node_plugins}RobotStateAggregator;
    $<TARGET_FILE:robot_state_aggregator_main>\n")

add_executable(robot_state_aggregator
  src/robot_state_aggregator/main.cpp
)

if(DEFINED ENV{RMF_ENABLE_FAILOVER})
  if($ENV{RMF_ENABLE_FAILOVER} EQUAL 1)
    add_compile_definitions(FAILOVER_MODE)
    set(robot_state_aggregator_main_libs
      robot_state_aggregator_main
      stubborn_buddies::lifecycle_watchdog
      stubborn_buddies::lifecycle_heartbeat
    )
  else()
    set(robot_state_aggregator_main_libs
      robot_state_aggregator_main
    )
  endif()
else()
  set(robot_state_aggregator_main_libs
    robot_state_aggregator_main
  )
endif()


if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(robot_state_aggregator_main_libs
    "-Wl,--no-as-needed"
    ${robot_state_aggregator_main_libs}
    "-Wl,--as-needed")
endif()

target_link_libraries(robot_state_aggregator
  ${robot_state_aggregator_main_libs})

ament_target_dependencies(robot_state_aggregator
  "class_loader"
  "rclcpp"
  "rclcpp_components"
)

# -----------------------------------------------------------------------------

add_executable(test_read_only_adapter
  test/test_read_only_adapter.cpp
)

target_link_libraries(test_read_only_adapter
  PRIVATE
    rmf_fleet_adapter
)

# -----------------------------------------------------------------------------

add_executable(dump_fleet_states
  test/dump_fleet_states.cpp
)

target_link_libraries(dump_fleet_states
  PRIVATE
    rmf_fleet_adapter
    ${rclcpp_LIBRARIES}
    ${rmf_fleet_msgs_LIBRARIES}
)

target_include_directories(dump_fleet_states
  PRIVATE
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_fleet_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(task_aggregator
  src/task_aggregator/main.cpp
)

target_link_libraries(task_aggregator
  PRIVATE
    rmf_fleet_adapter
    ${rclcpp_LIBRARIES}
    ${rmf_task_msgs_LIBRARIES}
)

target_include_directories(task_aggregator
  PRIVATE
    ${rclcpp_INCLUDE_DIRS}
    ${rmf_task_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(open_lanes src/open_lanes/main.cpp)

target_link_libraries(open_lanes
  PRIVATE
    ${rmf_fleet_msgs_LIBRARIES}
    rclcpp::rclcpp
    rmf_fleet_adapter
)

target_include_directories(open_lanes
  PRIVATE
    ${rmf_fleet_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(close_lanes src/close_lanes/main.cpp)

target_link_libraries(close_lanes
  PRIVATE
    ${rmf_fleet_msgs_LIBRARIES}
    rclcpp::rclcpp
    rmf_fleet_adapter
)

target_include_directories(close_lanes
  PRIVATE
    ${rmf_fleet_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

add_executable(interrupt_robot src/interrupt_robot/main.cpp)

target_link_libraries(interrupt_robot
  PRIVATE
    ${rmf_fleet_msgs_LIBRARIES}
    rclcpp::rclcpp
    rmf_fleet_adapter
)

target_include_directories(interrupt_robot
  PRIVATE
    ${rmf_fleet_msgs_INCLUDE_DIRS}
)

# -----------------------------------------------------------------------------

rmf_api_generate_schema_headers(
  PACKAGE rmf_fleet_adapter
  SCHEMAS_DIR ${CMAKE_CURRENT_LIST_DIR}/schemas
)

# -----------------------------------------------------------------------------

ament_export_targets(rmf_fleet_adapter HAS_LIBRARY_TARGET)
ament_export_dependencies(${dep_pkgs})

install(
  TARGETS
    rmf_fleet_adapter
    read_only
    read_only_blockade
    mock_traffic_light
    full_control
    lift_supervisor
    experimental_lift_watchdog
    door_supervisor
    robot_state_aggregator

=== rmf_rxcpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(Threads REQUIRED)

add_library(rmf_rxcpp INTERFACE)

target_include_directories(rmf_rxcpp
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/RxCpp-4.1.0/Rx/v2/src
    ${rclcpp_INCLUDE_DIRS}
)
target_link_libraries(rmf_rxcpp
  INTERFACE
    Threads::Threads
    ${rclcpp_LIBRARIES}
)

# Issues in RMW implementations are causing spurious failures for these tests,
# possibly due to race conditions in the memory management of the underlying
# middleware implementations while the test spins up and tears down rclcpp nodes
# too quickly. This is giving us spurious test failures in the CI, so we will
# simply disable these tests since this code is heading towards retirement
# anyway.
# if(BUILD_TESTING)
#   find_package(ament_cmake_catch2 REQUIRED)
#   find_package(rmf_utils REQUIRED)
#   find_package(std_msgs REQUIRED)
#   find_package(ament_cmake_uncrustify REQUIRED)
#   find_file(uncrustify_config_file NAMES
#     NAMES "rmf_code_style.cfg"
#     PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")

#   ament_add_catch2(
#     test_rmf_rxcpp
#       test/main.cpp
#       test/test_RxJobs.cpp
#       test/test_Transport.cpp
#   )
#   target_include_directories(test_rmf_rxcpp
#     PRIVATE
#       ${std_msgs_INCLUDE_DIRS}
#   )
#   target_link_libraries(test_rmf_rxcpp
#     PRIVATE
#       rmf_rxcpp
#       rmf_utils::rmf_utils
#       ${std_msgs_LIBRARIES}
#   )

#   find_package(rmf_traffic REQUIRED)

#   add_executable(rmf_rxcpp_example_plan_path examples/PlanPath.cpp)

#   target_link_libraries(rmf_rxcpp_example_plan_path
#     PUBLIC
#       rmf_traffic::rmf_traffic
#       rmf_rxcpp
#   )

# endif()

=== debian/changelog ===
ros-rolling-rmf-fleet-adapter (2.3.2-1jammy) jammy; urgency=high

  * Improve linking time (#297 <https://github.com/open-rmf/rmf_ros2/pull/297>)
  * EasyFullControl API (#235 <https://github.com/open-rmf/rmf_ros2/pull/235>)
  * Contributors: Grey, Luca Della Vedova, Xiyu, Yadunund

 -- Grey <grey@openrobotics.org>  Sun, 27 Aug 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.3.1-1jammy) jammy; urgency=high

  * Remove duplicate task schemas (#294 <https://github.com/open-rmf/rmf_ros2/pull/294>)
  * Fix comparator for direct assignment ordering (#288 <https://github.com/open-rmf/rmf_ros2/pull/288>)
  * Adding initiator and request time to booking (#267 <https://github.com/open-rmf/rmf_ros2/pull/267>)
  * Contributors: Aaron Chong, Omar Hamza, Yadunund

 -- Grey <grey@openrobotics.org>  Wed, 09 Aug 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.3.0-1jammy) jammy; urgency=high



 -- Grey <grey@openrobotics.org>  Wed, 07 Jun 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.2.0-1jammy) jammy; urgency=high

  * Fix race condition related to the ``finished`` callback of ``perform_action`` events: (#273 <https://github.com/open-rmf/rmf_ros2/pull/273>)
  * Switch to rst changelogs (#276 <https://github.com/open-rmf/rmf_ros2/pull/276>)
  * Contributors: Grey, Yadunund

 -- Grey <grey@openrobotics.org>  Mon, 05 Jun 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.1.5-1jammy) jammy; urgency=high

  * Reformat code to meet expectations of uncrustify-0.72.0: (#274 <https://github.com/open-rmf/rmf_ros2/pull/274>)
  * Contributors: Yadunund

 -- Grey <grey@openrobotics.org>  Fri, 19 May 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.1.4-1jammy) jammy; urgency=high



 -- Grey <grey@openrobotics.org>  Wed, 26 Apr 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.1.3-1jammy) jammy; urgency=high

  * Fix emergency response for waiting robots: (#253 <https://github.com/open-rmf/rmf_ros2/pull/253>)
  * Properly cleanup emergency pullover task: (#258 <https://github.com/open-rmf/rmf_ros2/pull/258>)
  * Fix priority assignment when parsing tasks: (#265 <https://github.com/open-rmf/rmf_ros2/pull/265>)
  * Link Threads to fix build errors on certain platforms: (#204 <https://github.com/open-rmf/rmf_ros2/pull/204>)
  * Contributors: decada-robotics, Luca Della Vedova, Grey, Yadunund

 -- Grey <grey@openrobotics.org>  Tue, 25 Apr 2023 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.1.2-1jammy) jammy; urgency=high



 -- Grey <grey@openrobotics.org>  Sun, 09 Oct 2022 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.1.0-1jammy) jammy; urgency=high

  * Add API to update speed limits for lanes: (#217 <https://github.com/open-rmf/rmf_ros2/pull/217>)
  * Make async behaviors more robust: (#228 <https://github.com/open-rmf/rmf_ros2/pull/228>)
  * Allow fleet adapters to change schedule participant profiles: (#229 <https://github.com/open-rmf/rmf_ros2/pull/229>)
  * Allow robots to be decommissioned from the task dispatch system: (#233 <https://github.com/open-rmf/rmf_ros2/pull/233>)
  * Allow manual toggling of stubborn negotiation: (#196 <https://github.com/open-rmf/rmf_ros2/pull/196>)
  * Allow users to specify a custom update listener: (#198 <https://github.com/open-rmf/rmf_ros2/pull/198>)
  * Introduce WaitUntil activity and use it in the ResponsiveWait: (#199 <https://github.com/open-rmf/rmf_ros2/pull/199>)
  * Better support for patrol behaviors: (#205 <https://github.com/open-rmf/rmf_ros2/pull/205>)
  * Allow ResponsiveWait to be enabled and disabled: (#209 <https://github.com/open-rmf/rmf_ros2/pull/209>)
  * Publish the navigation graph of the fleet adapter: (#207 <https://github.com/open-rmf/rmf_ros2/pull/207>)
  * Allow robot status to be overridden by the user: (#191 <https://github.com/open-rmf/rmf_ros2/pull/191>)
  * Add API to report status for perform_action: (#190 <https://github.com/open-rmf/rmf_ros2/pull/190>)
  * Add APIs for cancelling and killing tasks from the RobotUpdateHandle: (#205 <https://github.com/open-rmf/rmf_ros2/pull/205>)
  * Add a WaitUntil event and use it for ResponsiveWait: (#199 <https://github.com/open-rmf/rmf_ros2/pull/199>)

 -- Grey <grey@openrobotics.org>  Sun, 02 Oct 2022 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (2.0.0-1jammy) jammy; urgency=high

  * Update to traffic dependency system: (#188 <https://github.com/open-rmf/rmf_ros2/pull/188>)

 -- Grey <grey@openrobotics.org>  Thu, 17 Mar 2022 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (1.5.0-1jammy) jammy; urgency=high

  * Support flexible task definitions (#168 <https://github.com/open-rmf/rmf_ros2/pull/168>)
  * Add lane speed limit to graph parsing function (#124 <https://github.com/open-rmf/rmf_ros2/pull/124>)
  * Support for geojson graphs (#142 <https://github.com/open-rmf/rmf_ros2/pull/142>)

 -- Grey <grey@openrobotics.org>  Sun, 13 Feb 2022 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (1.4.0-1jammy) jammy; urgency=high

  * Add read_only_blockade adapter: (#110 <https://github.com/open-rmf/rmf_ros2/pull/110>)
  * Accommodate finishing tasks: (#108 <https://github.com/open-rmf/rmf_ros2/pull/109>)
  * Check if lane request's fleet_name is equal to the fleet's fleet_name: (#95 <https://github.com/open-rmf/rmf_ros2/pull/95>)
  * Find nearest waypoint among starts: (#98 <https://github.com/open-rmf/rmf_ros2/pull/98>)

 -- Grey <grey@openrobotics.org>  Tue, 31 Aug 2021 16:00:00 -0000

ros-rolling-rmf-fleet-adapter (1.3.0-1jammy) jammy; urgency=high

  * Add API for opening and closing lanes: (#15)
    
    Added open_lanes and close_lanes CLI tools for issuing requests
  * Allow Traffic Light APIs to update the location of a robot while it is idle: (#270 <https://github.com/osrf/rmf_core/pull/270>)
  * Allow TrafficLight and EasyTrafficLight API to update battery level: (#263 <https://github.com/osrf/rmf_core/pull/263>)
  * Migrating to a task dispatcher framework: (#21)
    


=== debian/control ===
Source: ros-rolling-rmf-fleet-adapter
Section: misc
Priority: optional
Maintainer: Grey <grey@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libyaml-cpp-dev, nlohmann-json3-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-catch2 <!nocheck>, ros-rolling-ament-cmake-uncrustify <!nocheck>, ros-rolling-nlohmann-json-schema-validator-vendor, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rmf-api-msgs, ros-rolling-rmf-battery, ros-rolling-rmf-building-map-msgs, ros-rolling-rmf-dispenser-msgs, ros-rolling-rmf-door-msgs, ros-rolling-rmf-fleet-msgs, ros-rolling-rmf-ingestor-msgs, ros-rolling-rmf-lift-msgs, ros-rolling-rmf-task, ros-rolling-rmf-task-msgs, ros-rolling-rmf-task-ros2, ros-rolling-rmf-task-sequence, ros-rolling-rmf-traffic, ros-rolling-rmf-traffic-ros2, ros-rolling-rmf-utils, ros-rolling-rmf-websocket, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rmf-fleet-adapter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, nlohmann-json3-dev, ros-rolling-nlohmann-json-schema-validator-vendor, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rmf-api-msgs, ros-rolling-rmf-battery, ros-rolling-rmf-building-map-msgs, ros-rolling-rmf-dispenser-msgs, ros-rolling-rmf-door-msgs, ros-rolling-rmf-fleet-msgs, ros-rolling-rmf-ingestor-msgs, ros-rolling-rmf-lift-msgs, ros-rolling-rmf-task, ros-rolling-rmf-task-msgs, ros-rolling-rmf-task-ros2, ros-rolling-rmf-task-sequence, ros-rolling-rmf-traffic, ros-rolling-rmf-traffic-ros2, ros-rolling-rmf-utils, ros-rolling-rmf-websocket, ros-rolling-std-msgs, ros-rolling-ros-workspace
Description: Fleet Adapter package for RMF fleets.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
